/**
 *	@file	v_string.h
 *	@brief	vectordlclass basic_string dl̕NXA_v^
 *	@author	tenk* (Masashi Kitamura)
 *	@date	2006,2010
 *	@note
 *		- c_str() '\0'̕t́Ac_str()ɍsB
 *		  resize()ł͗]1mۂāAȂׂ c_str()resize()
 *		  Ȃ悤ɂĂ.
 *		- {IɃRs[TRAITS::copyōsĂ邪
 *		  Ce[^ɂ͂̏ꍇ std::copy gĂ.
 *		- ꉞAO𓊂̂ftHgAOstd::stringg߁A
 *		  {]|. UNUSE_THROW `Ăassert`FbNɕύX.
 *		- Jn̕ʒuw(,Ce[^)͈͊Ȍꍇ̓G[A
 *		  TCY/IʒuI[o[Ăꍇ͗L͈͂̍őlƂĈ
 *		  G[ɂȂ.
 *		- L̂悤ɗOassert̔肪Ac++W̃mƈႤ̂Œ.
 *		  Ӑ}IȂ̂邪 vc7.1̃m^Ăvc8狓Ă.
 *		- |Iȑ㕨ŁAǂɕʂstringNX쐬(ya_string)
 *		  G[̈͂ł͏CA͏CĂȂ.
 *		- Public Domain Software
 */
#ifndef V_STRING_H
#define V_STRING_H

#include <cstddef>
#include <cstring>
#include <iterator>
#include <algorithm>
#include <stdexcept>
#include <vector>
#ifndef assert
#include <cassert>
#endif


// UNUSE_THROW `΁AO𓊂ȂȂ
// #define UNUSE_THROW


// `ꍇAsize() < capacity()ɂ'\0'KB
// `̏ꍇ́Ac_str()̂Ƃɂ̂ݕt.
// #define V_STRING_ALWAYS_APPEND_NULL_CHAR



// ============================================================================
// 
// ============================================================================

/// basic_v_stringňɊւ traits. ق std::char_traitsƓl.
template<typename charT>
struct v_char_traits {
	typedef charT		 			char_type;
	typedef int 					int_type;
	typedef unsigned				pos_type;
	typedef int 					off_type;
	typedef unsigned				state_type;
	typedef typename std::size_t	size_type;

private:
	//typedef ucharT		char_cmp_type;
	typedef charT			char_cmp_type;

public:
	static int_type 		eof() { return -1; }
	static int_type 		not_eof( const int_type& c ) { return c >= 0 ? c : 0; }
	static bool 			eq( const char_type& a, const char_type& b ) {return (a == b); }

	static bool 			eq_int_type( const int_type& a, const int_type& b ) { return (a == b); }
	static bool 			lt( const char_type& a, const char_type& b ) { return char_cmp_type(a) < char_cmp_type(b); }
	static void 			assign( char_type& d, const char_type& s ) { d = s; }

	static char_type 		to_char_type( const int_type& c ) { return char_type(c); }
	static int_type 		to_int_type( const char_type& c ) { return char_cmp_type(c); }

	static char_type*		assign( char_type* dst, std::size_t n, const char_type& c );
	static char_type*		copy( char_type* dst, const char_type* s, size_t n );
	static char_type*		move( char_type* dst, const char_type* s, size_t n );
	static size_type 		length( const char_type *str );
	static int		 		compare( const char_type* a, const char_type* b, size_type n );
	static const char_type* find( const char_type* str, size_type n, const char_type& k );
};



//-----------------------------------------------------------------------------
// .
//-----------------------------------------------------------------------------

template<typename charT>
charT* v_char_traits<charT>::assign(charT* dst, std::size_t n, const charT& c)
{
	assert(dst != NULL);
	if (n) {
		charT *d = dst;
		charT *e = d + n;
		do {
			*d++ = c;
		} while (d != e);
	}
	return dst;
}


template<typename charT>
charT* v_char_traits<charT>::copy(charT* dst, const charT* s, std::size_t n)
{
	assert(dst != NULL);
	assert(s   != NULL);
	if (n) {
		charT *d = dst;
		charT *e = d + n;
		do {
			*d++ = *s++;
		} while (d != e);
	}
	return dst;
}


template<typename charT>
charT* v_char_traits<charT>::move(charT* dst, const charT* s, std::size_t n)
{
	assert(dst != NULL && s != NULL);
	if ((n != 0) & (dst != 0)) {
		charT *d = dst;
		if (d < s) {
			charT *e = d + n;
			do {
				*d++ = *s++;
			} while (d != e);
		} else if (d > s) {
			d += n;
			s += n;
			do {
				*--d = *--s;
			} while (d != dst);
		}
	}
	return dst;
}



template<typename charT>
std::size_t v_char_traits<charT>::length(const charT *str)
{
	std::size_t 	l  = 0;
	const charT *s = str;
	if (s) {
		while (*s != charT())
			++s;
		l = s - str;
	}
	return l;
}



template<typename charT>
int		v_char_traits<charT>::compare( const charT* a, const charT* b, std::size_t n )
{
	assert(a != NULL && b != NULL);
	const char_cmp_type *l = (const char_cmp_type *)a;
	const char_cmp_type *r = (const char_cmp_type *)b;
	const char_cmp_type *e = l + n;
	int c = 0;
	while (l != e && ((c = *l - *r++) == 0) && (*l != charT()))
		++l;
	return c;
}



template<typename charT>
const charT* v_char_traits<charT>::find(const charT* src, std::size_t n, const charT& key)
{
	if (n && src) {
		const char_cmp_type *s = (const char_cmp_type *)src;
		const char_cmp_type *e = s + n;
		const char_cmp_type  k = char_cmp_type(key);
		do {
			if (*s == k)
				return reinterpret_cast<const charT *>(s);
			++s;
		} while (s != e);
	}
	return NULL;
}



//-----------------------------------------------------------------------------
// char p̎.
//-----------------------------------------------------------------------------

/** charpłv_char_traits.
 * IveB}CYinlineWJ邱Ƃ҂
 * WC֐memset,memcpy,memcmp,memchr,memmovepĎ.
 */
template<>
struct v_char_traits<char> {
	typedef char	   		char_type;
	typedef int 			int_type;
	typedef unsigned		pos_type;
	typedef int 			off_type;
	typedef unsigned		state_type;
	typedef std::size_t		size_type;

private:
	typedef unsigned char	char_cmp_type;

public:
	static int_type 		eof() { return -1; }
	static int_type 		not_eof( int_type c ) { return c >= 0 ? c : 0; }
	static bool 			eq( char_type a, char_type b ) {return (a == b); }
	static bool 			eq_int_type( int_type a, int_type b ) { return (a == b); }
	static bool 			lt( char_type a, char_type b ) { return char_cmp_type(a) < char_cmp_type(b); }
	static void 			assign( char_type& d, char_type s ) { d = s; }
	static char_type 		to_char_type( int_type c ) { return char_type(c); }
	static int_type 		to_int_type( char_type c ) { return char_cmp_type(c); }

	static char_type*		assign( char_type* dst, std::size_t n, char_type c ) { return (char_type*)::memset(dst, c, n); }
	static char_type*		copy( char_type* dst, const char_type* src, size_t n ) { return (char_type*)::memcpy(dst,src,n); }
	static char_type*		move( char_type* dst, const char_type* src, size_t n ) { return (char_type*)::memmove(dst,src,n); }
	static size_type 		length( const char_type *str ) { return ::strlen(str); }
	static int		 		compare( const char_type* a, const char_type* b, size_type n ) { return ::memcmp(a,b,n); }
	static const char_type* find( const char_type* src, size_type n, char_type key ) { return (char_type*)::memchr(src,key,n); }
};



// ============================================================================
// NX
// ============================================================================

/// vector  string A_v^
template< typename C, class T=v_char_traits<C>, class V=std::vector<C> >
class basic_v_string {
	V						vec_;

private:
	typedef basic_v_string	this_type;
	typedef V				base_type;

public:
	// ^
	typedef C										char_type;
	typedef std::size_t								size_type;
	typedef typename base_type::difference_type		difference_type;
	typedef typename base_type::pointer				pointer;
	typedef typename base_type::const_pointer		const_pointer;
	typedef typename base_type::reference			reference;
	typedef typename base_type::const_reference		const_reference;
	typedef typename base_type::iterator			iterator;
	typedef typename base_type::const_iterator		const_iterator;
	typedef std::reverse_iterator<iterator> 		reverse_iterator;
	typedef std::reverse_iterator<const_iterator>	const_reverse_iterator;
	typedef typename V::allocator_type				allocator_type;
	static const unsigned npos;		//x enum { npos = size_type(-1) };

	// RXgN^fXgN^
	basic_v_string() {}																	///< ftHgRXgN^
	//x explicit basic_v_string(std::size_t n);											///< n̋
	basic_v_string(size_type n, char_type c);											///< ncŏ
	basic_v_string(const char_type* cstr);												///< s̏I܂
	basic_v_string(const char_type* cary, size_type n);									///< sn
	basic_v_string(const basic_v_string& str);											///< Rs[RXgN^
	basic_v_string(const basic_v_string& str, size_type pos, size_type n=npos);			///< strposڂn
	template<class InpIte> basic_v_string(InpIte first, InpIte last);					///< Ce[^ŏ
	~basic_v_string() {}																///< fXgN^

	// TCY
	bool 			empty() const { return vec_.size() == 0; }							///< Ȃtrue
	size_type 		size() const {	return vec_.size(); }								///< Ԃ
	size_type 		length() const { return vec_.size(); }								///< Ԃ
	size_type 		max_size() const { return vec_.max_size();}							///< mۉ\ȍő啶Ԃ
	void 			resize(size_type n);												///< nɕύX(char_type()Ŗ߂)
	void 			resize(size_type n, char_type c);									///< nɕςAcŖ߂.
	size_type 		capacity() const { return vec_.capacity(); }						///< ݂̃obt@TCY.
	void 			reserve(size_type l = 0) { assert(l < npos); vec_.reserve(l+1); }	///< obt@TCYύX.

	// ANZX
	const char_type* 		c_str() const;												///< '\0'I[̃AhXԂ.
	const char_type* 		data()	const { return &vec_[0]; }							///< f[^{̂̂܂ܕԂ.('\0'̗L͕s)
	const_reference operator[](size_type i) const { assert(i<size()); return vec_[i];}	///< iڂ̕Ԃ.
	reference		operator[](size_type i)		  { assert(i<size()); return vec_[i];}	///< iڂ̕Ԃ.
	const_reference at(size_type i) const { return vec_.at(i); }						///< iڂ̕Ԃ. ͈͊OȂO𓊂.
	reference 		at(size_type i)		  { return vec_.at(i); }						///< iڂ̕Ԃ. ͈͊OȂO𓊂.

	// Ce[^
	iterator 			   begin() 		  { return vec_.begin(); }						///< 擪ւ̃Ce[^Ԃ
	const_iterator 		   begin()	const { return vec_.begin(); }						///< 擪ւ̃Ce[^Ԃ
	const_iterator 		   cbegin() const { return vec_.begin(); }						///< 擪ւ̃Ce[^Ԃ
	iterator 			   end()		  { return vec_.end(); }						///< I[(̎)wCe[^Ԃ
	const_iterator 		   end()	const { return vec_.end(); }						///< I[(̎)wCe[^Ԃ
	const_iterator 		   cend()	const { return vec_.end(); }						///< I[(̎)wCe[^Ԃ
	reverse_iterator	   rbegin() 	  { return reverse_iterator( end() );}			///< 擪wtCe[^Ԃ
	const_reverse_iterator rbegin() const { return const_reverse_iterator(end());}		///< 擪wtCe[^Ԃ
	const_reverse_iterator crbegin()const { return const_reverse_iterator(end());}		///< 擪wtCe[^Ԃ
	reverse_iterator	   rend()		  { return reverse_iterator( begin() ); }		///< I[(̎)wtCe[^Ԃ
	const_reverse_iterator rend()	const { return const_reverse_iterator(begin());}	///< I[(̎)wtCe[^Ԃ
	const_reverse_iterator crend()	const { return const_reverse_iterator(begin());}	///< I[(̎)wtCe[^Ԃ

	// r
	int compare(const basic_v_string& str) const;
	int compare(size_type pos1, size_type n1, const basic_v_string& str) const;
	int compare(size_type pos1, size_type n1, const basic_v_string& str, size_type pos2, size_type n2) const;
	int compare(const char_type* s) const;
	int compare(const char_type* s, size_type n) const;
	int compare(size_type pos1, size_type n1, const char_type* cstr) const;
	int compare(size_type pos1, size_type n1, const char_type* cary, size_type n2) const;

	// 
	basic_v_string& operator=(const basic_v_string& str);
	basic_v_string& operator=(const char_type* cstr);
	basic_v_string& operator=(char_type c);
	basic_v_string& assign(const basic_v_string& str);
	basic_v_string& assign(const basic_v_string& str, size_type pos, size_type n=npos);
	basic_v_string& assign(const char_type* cstr);
	basic_v_string& assign(const char_type* cary, size_type n);
	basic_v_string& assign(size_type n, char_type c);
	template<class InpIte> basic_v_string& assign(InpIte first, InpIte last);

	// ǉ
	basic_v_string& operator+=(const basic_v_string& str);
	basic_v_string& operator+=(const char_type* cstr);
	basic_v_string& operator+=(char_type c);
	basic_v_string& append(const basic_v_string& str);
	basic_v_string& append(const basic_v_string& str, size_type pos, size_type n=npos);
	basic_v_string& append(const char_type* cstr);
	basic_v_string& append(const char_type* cary, size_type n);
	basic_v_string& append(size_type n, char_type c);
	template<class InpIte> basic_v_string& append(InpIte first, InpIte last);

	// }
	basic_v_string& insert(size_type pos1, const basic_v_string& str, size_type pos2 = 0, size_type n = npos);
	basic_v_string& insert(size_type pos, const char_type* cstr, size_type n);
	basic_v_string& insert(size_type pos, const char_type* cary);
	basic_v_string& insert(size_type pos, size_type n, char_type c);
	iterator  insert(iterator p, char_type c);
	void insert(iterator p, size_type n, char_type c);
	template<typename InpIte> void insert(iterator p, InpIte first, InpIte last);

	// 폜
	basic_v_string& erase(size_type pos = 0, size_type n = npos);
	iterator erase(iterator pos);
	iterator erase(iterator first, iterator last);

	// u
	basic_v_string& replace(size_type pos1, size_type n1, const basic_v_string& str2, size_type pos2 = 0, size_type n2 = npos);
	basic_v_string& replace(size_type pos1, size_type n1, const char_type* cstr2);
	basic_v_string& replace(size_type pos1, size_type n1, const char_type* cary2, size_type n2);
	basic_v_string& replace(size_type pos1, size_type n1, size_type n2, char_type c2);
	basic_v_string& replace(iterator fi, iterator li, const basic_v_string& str);
	basic_v_string& replace(iterator fi, iterator li, const char_type* cstr);
	basic_v_string& replace(iterator fi, iterator li, const char_type* cary, size_type n);
	basic_v_string& replace(iterator fi, iterator li, size_type n, char_type c);
	template<class InpIte> basic_v_string& replace(iterator fi1, iterator li1, InpIte fi2, InpIte li2);

	// ()̏
	size_type find(char_type c2) const;
	size_type find(char_type c2, size_type pos1) const;
	size_type find(const basic_v_string& str2) const;
	size_type find(const basic_v_string& str2, size_type pos1) const;
	size_type find(const char_type* cstr2) const;
	size_type find(const char_type* cstr2, size_type pos1) const;
	size_type find(const char_type* cary2, size_type pos1, size_type n2) const;

	// ()̋t
	size_type rfind(char_type c) const;
	size_type rfind(char_type c, size_type pos) const;
	size_type rfind(const basic_v_string& str) const;
	size_type rfind(const basic_v_string& str, size_type pos) const;
	size_type rfind(const char_type* cstr) const;
	size_type rfind(const char_type* cstr, size_type pos) const;
	size_type rfind(const char_type* cstr, size_type pos, size_type n) const;

	// w蕶̏
	size_type find_first_of(char_type c) const;
	size_type find_first_of(char_type c, size_type pos) const;
	size_type find_first_of(const basic_v_string& str) const;
	size_type find_first_of(const basic_v_string& str, size_type pos) const;
	size_type find_first_of(const char_type *cstr) const;
	size_type find_first_of(const char_type *cstr, size_type pos) const;
	size_type find_first_of(const char_type *cstr, size_type pos, size_type n) const;

	// w蕶̋t
	size_type find_last_of(char_type c) const;
	size_type find_last_of(char_type c, size_type pos) const;
	size_type find_last_of(const basic_v_string& str) const;
	size_type find_last_of(const basic_v_string& str, size_type pos) const;
	size_type find_last_of(const char_type *cstr) const;
	size_type find_last_of(const char_type *cstr, size_type pos) const;
	size_type find_last_of(const char_type *cstr, size_type pos, size_type n) const;

	// w蕶ȊȌ
	size_type find_first_not_of(char_type c) const;
	size_type find_first_not_of(char_type c, size_type pos) const;
	size_type find_first_not_of(const basic_v_string& str) const;
	size_type find_first_not_of(const basic_v_string& str, size_type pos) const;
	size_type find_first_not_of(const char_type *cstr) const;
	size_type find_first_not_of(const char_type *cstr, size_type pos) const;
	size_type find_first_not_of(const char_type *cstr, size_type pos, size_type n) const;

	// w蕶ȊŐt
	size_type find_last_not_of(char_type c) const;
	size_type find_last_not_of(char_type c, size_type pos) const;
	size_type find_last_not_of(const basic_v_string& str) const;
	size_type find_last_not_of(const basic_v_string& str, size_type pos) const;
	size_type find_last_not_of(const char_type *cstr) const;
	size_type find_last_not_of(const char_type *cstr, size_type pos) const;
	size_type find_last_not_of(const char_type *cstr, size_type pos, size_type n) const;

	// sposڂnRs[
	size_type copy(char_type* cary, size_type n, size_type pos = 0) const;

	// sƂ̓ꊷ
	void swap(basic_v_string& str2) { vec_.swap(str2.vec_); }

	// posڂnAVKĕԂ.
	basic_v_string substr(size_type pos = 0, size_type n = npos) const;

	// // AP[^Ԃ.
	//x allocator_type get_allocator() const { return vec_.get_allocator(); }

private:
	pointer		   ptr(std::size_t pos) 	  { return &vec_[0] + pos; }
	const_pointer  ptr(std::size_t pos) const { return &vec_[0] + pos; }
	iterator	   ite(std::size_t pos) 	  { return begin() + pos; }
	const_iterator ite(std::size_t pos) const { return begin() + pos; }

	void		check_pos(std::size_t& pos) const;
	void		check_pos_len(std::size_t& pos, std::size_t& len) const;
	void		check_pos(iterator& pos) const;
	void		check_range(iterator& first, iterator& last) const;
	void		throw_out_of_range() const;

  #ifdef V_STRING_ALWAYS_APPEND_NULL_CHAR
	void		append_eos();
  #endif

	static std::size_t	find_1(const char_type* cary1, std::size_t ofs1, std::size_t n1, char_type c2);
	static std::size_t	find_str(const char_type* cary1, std::size_t ofs1, std::size_t n1, const char_type* cary2, std::size_t n2);
	static std::size_t	rfind_1(const char_type* cary1, std::size_t n1, char_type c2);
	static std::size_t	rfind_str(const char_type* cary1, std::size_t n1, const char_type* cary2, std::size_t n2);
	static std::size_t	fnd_first_of(const char_type* cary1, std::size_t ofs1, std::size_t n1, const char_type* cary2, std::size_t n2);
	static std::size_t	fnd_last_of(const char_type* cary1, std::size_t n1, const char_type* cary2, std::size_t n2);
	static std::size_t	fnd_first_not_of(const char_type* cary1, std::size_t ofs1, std::size_t n1, char_type c2);
	static std::size_t	fnd_first_not_of(const char_type* cary1, std::size_t ofs1, std::size_t n1, const char_type* cary2, std::size_t n2);
	static std::size_t	fnd_last_not_of(const char_type* cary1, std::size_t n1, char_type c2);
	static std::size_t	fnd_last_not_of(const char_type* cary1, std::size_t n1, const char_type* cary2, std::size_t n2);
};


template< typename C, class T, class V >
const unsigned basic_v_string<C,T,V>::npos = ((unsigned)-1);




typedef basic_v_string< char   , v_char_traits<char   >, std::vector<char>	  >	v_string;
typedef basic_v_string< wchar_t, v_char_traits<wchar_t>, std::vector<wchar_t> >	v_wstring;




//---------------------------------------------------------------------------------
//---------------------------------------------------------------------------------
// 
//---------------------------------------------------------------------------------
//---------------------------------------------------------------------------------

// -------------------------------
// private
// -------------------------------

#ifdef V_STRING_ALWAYS_APPEND_NULL_CHAR
#define V_STRING_APPEND_EOS()		append_eos()
/// I[\0̕t(V_STRING_ALWAYS_APPEND_NULL_CHAR`̂)
/// [private]
template< typename C, class T, class V > inline
void basic_v_string<C,T,V>::append_eos() {
	if (size() >= capacity()) {
		vec_.resize(vec_.size()+1);
		vec_.pop_back();
	}
	*vec_.end() = char_type();
}
#else
#define V_STRING_APPEND_EOS()
#endif



/// std::out_of_range 𓊂.
/// [private]
template< typename C, class T, class V > inline
void basic_v_string<C,T,V>::throw_out_of_range() const
{
  #if defined UNUSE_THROW == 0
	//  std::string ĝ... ܂悭Ȃ
	throw std::out_of_range("out of range in MISC::basic_v_string");
  #endif
}


/// ʒuwpos͈͊Oǂ`FbNA͈͊OȂstd::out_of_range𓊂.
/// [private]
template< typename C, class T, class V > inline
void basic_v_string<C,T,V>::check_pos(std::size_t& pos) const
{
	if (pos > vec_.size()) {
		throw_out_of_range();
		pos = vec_.size();
	}
}


/// ʒu񂪔͈͊OȂO𓊂. ܂AΒ.
/// [private]
template< typename C, class T, class V > inline
void basic_v_string<C,T,V>::check_pos_len(std::size_t& pos, std::size_t& len) const
{
	std::size_t l = vec_.size();
	if (pos > l) {
		throw_out_of_range();
		pos = l;
	}
	if (len > l - pos)
		len = l - pos;
}


/// ʒuwpos͈͊Oǂ`FbNA͈͊OȂstd::out_of_range𓊂.
/// [private]
template< typename C, class T, class V > inline
void basic_v_string<C,T,V>::check_pos(typename basic_v_string<C,T,V>::iterator& pos) const
{
	if (pos < begin() || end() < pos) {
		throw_out_of_range();
		pos = const_cast< this_type* >(this)->end();
	}
}



/// ͈͎w[first,last)͈͊Oǂ`FbN&
/// [private]
template< typename C, class T, class V > inline
void basic_v_string<C,T,V>::check_range(
		typename basic_v_string<C,T,V>::iterator&	first,
		typename basic_v_string<C,T,V>::iterator&	last
) const
{
	check_pos(first);

	if (last > end()) {
		last = const_cast< this_type* >(this)->end();
	} else if (last < first) {
		throw_out_of_range();
		last = const_cast< this_type* >(this)->begin();
	}
}



// -------------------------------
// TCY֌W

/** obt@ETCY nɕύX.
 *	 ۂɂ n+1mۂĈÖق\0zu₷.
 *		܂AV_STRING_ALWAYS_APPEND_NULL_CHAR` \0u悤ɂȂ.
 */
template< typename C, class T, class V > inline
void basic_v_string<C,T,V>::resize( std::size_t n )
{
	vec_.resize(n+1);
  #ifdef V_STRING_ALWAYS_APPEND_NULL_CHAR
  	// pop_backŁAĊmۂȂ̑O.
	vec_.back() = C();
  #endif
	vec_.pop_back();
}


/** ̒(length)nɕςāA傫ȂcŖ߂
 */
template< typename C, class T, class V >
void basic_v_string<C,T,V>::resize( std::size_t n, C c)
{
	size_type l = vec_.size();
	resize( n );
	if (l < n)
		T::assign(ptr(l), n-l, c);	//x std::fill( ptr(l), &vec_[n], c);
}



// -------------------------------

/** '\0'I[ւ̃|C^ԂB
 *	 const֐Aۂɂ͈Öق\0ޏB
 *	@@ꍇɂĂresize()s.
 */
#ifdef V_STRING_ALWAYS_APPEND_NULL_CHAR
template< typename C, class T, class V > inline
const C* basic_v_string<C,T,V>::c_str() const {
	return ptr(0);
}
#else
template< typename C, class T, class V >
const C* basic_v_string<C,T,V>::c_str() const {
	basic_v_string* own = const_cast< this_type* >(this);
	std::size_t		sz	= vec_.size();
	if (sz >= vec_.capacity()) {
		own->resize(sz+1);
	}
	(&*own->begin())[sz] = C();
	return ptr(0);
}
#endif



// -------------------------------
// RXgN^

#if 0
// n̋RXgN^
template< typename C, class T, class V > inline
basic_v_string<C,T,V>::basic_v_string(std::size_t n)
{
	resize(n, C());
}
#endif


/** nCȂ镶RXgN^.
 */
template< typename C, class T, class V > inline
basic_v_string<C,T,V>::basic_v_string(std::size_t n, C c)
{
	resize(n);
	if (n)
		T::assign(ptr(0), n, c);
}



/** cstrRs[RXgN^.
 */
template< typename C, class T, class V >
basic_v_string<C,T,V>::basic_v_string(const C* cstr)
{
	size_type	l = 0;
	if (cstr)
		l = T::length(cstr);
	resize(l);
	if (l)
		T::copy(ptr(0), cstr, l);
}



/** carynRs[RXgN^
 */
template< typename C, class T, class V >
basic_v_string<C,T,V>::basic_v_string(const C* cary, std::size_t n)
{
	resize(n);
	if (n)
		T::copy(ptr(0), cary, n);
}



/** Rs[RXgN^
 */
template< typename C, class T, class V > inline
basic_v_string<C,T,V>::basic_v_string(const basic_v_string<C,T,V>& str)
{
	size_type l = str.vec_.size();
	resize(l);
	if (l)
		T::copy( ptr(0), str.ptr(0), l);
}


/** strposڂnRs[RXgN^.
 */
template< typename C, class T, class V >
basic_v_string<C,T,V>::basic_v_string(const basic_v_string<C,T,V>& str, std::size_t pos, std::size_t n)
{
	str.check_pos_len(pos, n);
	resize(n);
	if (n)
		T::copy( ptr(0), str.ptr(pos), n);
}



/** Ce[^ŏRXgN^
 */
template< typename C, class T, class V >
template<class InpIte> inline
basic_v_string<C,T,V>::basic_v_string(InpIte first2, InpIte last2) {
	std::size_t	l2 = std::distance(first2, last2);
	resize(l2);
	if (l2)
		std::copy(first2, last2, ptr(0));
}




// -------------------------------
// 

/** str
 */
template< typename C, class T, class V > inline
basic_v_string<C,T,V>&
basic_v_string<C,T,V>::operator=(const basic_v_string<C,T,V>& str)
{
	return assign(str);
}


/** cstr
 */
template< typename C, class T, class V > inline
basic_v_string<C,T,V>&
basic_v_string<C,T,V>::operator=(const C* cstr)
{
	return assign(cstr);
}


/** c
 */
template< typename C, class T, class V > inline
basic_v_string<C,T,V>&
basic_v_string<C,T,V>::operator=(C c)
{
	resize(1);
	T::assign(vec_[0], c);
	return *this;
}


/** nc
 */
template< typename C, class T, class V > inline
basic_v_string<C,T,V>&
basic_v_string<C,T,V>::assign(std::size_t n, C c)
{
	resize(n);
	if (n) {
		T::assign(ptr(0), n, c);
	}
	return *this;
}




/** str
 */
template< typename C, class T, class V >
basic_v_string<C,T,V>&
basic_v_string<C,T,V>::assign( const basic_v_string<C,T,V>& str)
{
	if (this != &str) {
		size_type l = str.vec_.size();
		resize(l);
		if (l)
			T::copy( ptr(0), str.ptr(0), l );
	}
	return *this;
}


/** cstr 
 */
template< typename C, class T, class V >
basic_v_string<C,T,V>&
basic_v_string<C,T,V>::assign(const C*	cstr)
{
 #if 1
	basic_v_string(cstr).swap(*this);
	return *this;
 #else
	if (ptr(0) != cstr) {
		size_type l = T::length(cstr);
		resize(l);
		if (l)
			T::copy(ptr(0), cstr, l);
	}
	return *this;
 #endif
}


/** caryn
 */
template< typename C, class T, class V >
basic_v_string<C,T,V>&
basic_v_string<C,T,V>::assign(const C* cary, std::size_t n)
{
	resize(n);
	if (n)
		T::copy(ptr(0), cary, n );
	return *this;
}


/** strAposڂAnoĐݒ
 */
template< typename C, class T, class V >
basic_v_string<C,T,V>&
basic_v_string<C,T,V>::assign( const basic_v_string<C,T,V>& str, std::size_t pos, std::size_t n )
{
	if (this != &str) {
		str.check_pos_len(pos, n);
		resize(n);
		T::copy( ptr(0), str.ptr(pos), n );
	}
	return *this;
}


/** Ce[^̓͂
 */
template< typename C, class T, class V >
template<class InpIte>
basic_v_string<C,T,V>&
basic_v_string<C,T,V>::assign(InpIte first, InpIte last) {
	std::size_t	l = std::distance(first, last);
	resize(l);
	if (l)
		std::copy(first, last, ptr(0));
	return *this;
}




/** ary  posڂ nRs[
 */
template< typename C, class T, class V >
std::size_t
basic_v_string<C,T,V>::copy(C* ary, std::size_t n, std::size_t pos) const
{
	if (n == 0 || ary == 0)
		return 0;
	check_pos_len(pos, n);
	if (n)
		T::copy(ary, ptr(pos), n);
	return n;
}




/** posڂnAVKĕԂ
 */
template< typename C, class T, class V >
basic_v_string<C,T,V>
basic_v_string<C,T,V>::substr(std::size_t pos, std::size_t n) const
{
	check_pos_len(pos, n);
	return basic_v_string( ptr(pos), n );
}





// -------------------------------
// r
// a.compare(b) abƂ̔r. ʂstrcmp()ƓAȂa<bA0Ȃa==b, Ȃa>b\.


/** str2 Ɣr.
 * @return 		,0,(strcmp()ɓ)
 */
template< typename C, class T, class V >
int basic_v_string<C,T,V>::compare(const basic_v_string<C,T,V>& str2) const
{
	std::size_t l1 = vec_.size();
	std::size_t l2 = str2.vec_.size();
	difference_type	d  = difference_type(l1 - l2);
	if (d > 0)
		l1 = l2;
	int c = 0;
	if (l1 > 0)
		c = T::compare(ptr(0), str2.ptr(0), l1);
	if (c == 0)
		c = d;
	return c;
}



/* pos1ڂn1 str2 ƔrB
 * @return 		,0,(strcmp()ɓ)
 */
template< typename C, class T, class V >
int basic_v_string<C,T,V>::compare(std::size_t pos1, std::size_t n1, const basic_v_string<C,T,V>& str2) const
{
	std::size_t l1 = vec_.size();
	std::size_t l2 = str2.vec_.size();
	if (pos1 > l1)
		pos1 = l1;
	if (n1 > l1 - pos1)
		n1 = l1 - pos1;
	difference_type	d = difference_type (n1 - l2);
	if (d > 0)
		n1 = l2;
	int c = 0;
	if (n1 > 0)
		c = T::compare(ptr(pos1), str2.ptr(0), n1);
	if (c == 0)
		c = d;
	return c;
}



/** pos1ڂn1str2pos2ڂn2ƔrB
 * @return 		,0,(strcmp()ɓ)
 */
template< typename C, class T, class V >
int basic_v_string<C,T,V>::compare(std::size_t pos1, std::size_t n1
								, const basic_v_string<C,T,V>& str2, std::size_t pos2, std::size_t n2) const
{
	std::size_t l1 = vec_.size();
	std::size_t l2 = str2.vec_.size();
	if (pos1 > l1)
		pos1 = l1;
	if (n1 > l1 - pos1)
		n1 = l1 - pos1;
	if (pos2 > l2)
		pos2 = l2;
	if (n2 > l2 - pos2)
		n2 = l2 - pos2;
	int d = int (n1 - n2);
	if (d > 0)
		n1 = n2;
	int c = 0;
	if (n1 > 0)
		c = T::compare(ptr(pos1), str2.ptr(pos2), n1);
	if (c == 0)
		c = d;
	return c;
}



/** cstr2 Ƃ̔rsB
 * @return 		,0,(strcmp()ɓ)
 */
template< typename C, class T, class V >
int basic_v_string<C,T,V>::compare(const C* cstr2) const
{
	std::size_t l1 = vec_.size();
	std::size_t l2 = T::length(cstr2);
	difference_type d  = difference_type(l1 - l2);
	if (d > 0)
		l1 = l2;
	int c = 0;
	if (l1 > 0)
		c = T::compare(ptr(0), cstr2, l1);
	if (c == 0)
		c = d;
	return c;
}



/** cary2  nƔr
 * @return 		,0,(strcmp()ɓ)
 */
template< typename C, class T, class V >
int basic_v_string<C,T,V>::compare(const C* cary2, std::size_t n2) const
{
	std::size_t n1 = vec_.size();
	difference_type d  = difference_type(n1 - n2);
	if (d > 0)
		n1 = n2;
	int c = 0;
	if (n1 > 0)
		c = T::compare(ptr(0), cary2, n1);
	if (c == 0)
		c = d;
	return c;
}



/** pos1ڂn1  cstr2 r
 * @return 		,0,(strcmp()ɓ)
 */
template< typename C, class T, class V >
int basic_v_string<C,T,V>::compare(std::size_t pos1, std::size_t n1, const C* cstr2) const
{
	std::size_t l1 = vec_.size();
	std::size_t n2 = T::length(cstr2);
	if (pos1 > l1)
		pos1 = l1;
	if (n1 > l1 - pos1)
		n1 = l1 - pos1;
	difference_type d = difference_type(n1 - n2);
	if (d > 0)
		n1 = n2;
	int c = 0;
	if (n1 > 0)
		c = T::compare(ptr(pos1), cstr2, n1);
	if (c == 0)
		c = d;
	return c;
}



/** pos1ڂn1 cary2  n2Ɣr
 * @return 		,0,(strcmp()ɓ)
 */
template< typename C, class T, class V >
int basic_v_string<C,T,V>::compare(std::size_t pos1, std::size_t n1, const C* cary2, std::size_t n2) const
{
	std::size_t l1 = vec_.size();
	if (pos1 > l1)
		pos1 = l1;
	if (n1 > l1 - pos1)
		n1 = l1 - pos1;
	difference_type d = difference_type(n1 - n2);
	if (d > 0)
		n1 = n2;
	int c = 0;
	if (n1 > 0)
		c = T::compare(ptr(pos1), cary2, n1);
	if (c == 0)
		c = d;
	return c;
}



// -------------------------------
// ǉ

/** strǉ
 */
template< typename C, class T, class V > inline
basic_v_string<C,T,V>&
basic_v_string<C,T,V>::operator+=(const basic_v_string<C,T,V>& str)
{
	return append(str);
}


/** cstr̒ǉ
 */
template< typename C, class T, class V > inline
basic_v_string<C,T,V>&
basic_v_string<C,T,V>::operator+=(const C* cstr)
{
	return append(cstr);
}


/** c̒ǉ
 */
template< typename C, class T, class V > inline
basic_v_string<C,T,V>&
basic_v_string<C,T,V>::operator+=(C c)
{
	size_type l1 = vec_.size();
	resize(l1 + 1);
	T::assign(vec_[l1], c);
	return *this;
}


/** cnǉ
 */
template< typename C, class T, class V > inline
basic_v_string<C,T,V>&
basic_v_string<C,T,V>::append(std::size_t n, C c)
{
	if (n) {
		size_type l1 = vec_.size();
		resize(l1 + n);
		T::assign(ptr(l1), n, c);
	}
	return *this;
}


/** cstr̒ǉ
 */
template< typename C, class T, class V >
basic_v_string<C,T,V>&
basic_v_string<C,T,V>::append(const C*	cstr2)
{
	size_type l2 = T::length(cstr2);
	if (l2) {
		size_type l1 = vec_.size();
		resize(l1 + l2);
		T::copy(ptr(l1), cstr2, l2);
	}
	return *this;
}


/** carynǉ
 */
template< typename C, class T, class V >
basic_v_string<C,T,V>&
basic_v_string<C,T,V>::append(const C*	cary2, std::size_t n2)
{
	if (n2) {
		size_type l1 = vec_.size();
		resize(l1 + n2);
		T::copy(ptr(l1), cary2, n2);
	}
	return *this;
}


/** str2ǉ
 */
template< typename C, class T, class V >
basic_v_string<C,T,V>&
basic_v_string<C,T,V>::append( const basic_v_string<C,T,V>& str2)
{
	size_type l2 = str2.vec_.size();
	if (l2) {
		size_type l1 = vec_.size();
		resize(l1+l2);
		T::copy(ptr(l1), str2.ptr(0) , l2 );
	}
	return *this;
}


/** str2pos2n2ǉ
 */
template< typename C, class T, class V >
basic_v_string<C,T,V>&
basic_v_string<C,T,V>::append( const basic_v_string<C,T,V>& str2, std::size_t pos2, std::size_t n2 )
{
	str2.check_pos_len(pos2, n2);
	if (n2) {
		size_type l1 = vec_.size();
		resize(l1+n2);
		T::copy( ptr(l1), str2.ptr(pos2), n2 );
	}
	return *this;
}


/** Ce[^Œǉ
 */
template< typename C, class T, class V >
template<class InpIte>
basic_v_string<C,T,V>&
basic_v_string<C,T,V>::append(InpIte first, InpIte last) {
	std::size_t	l2 = std::distance(first, last);
	if (l2) {
		size_type 	l1 = vec_.size();
		resize(l1+l2);
		std::copy(first, last, ptr(l1));
	}
	return *this;
}




// -------------------------------
// 폜

/** posڂn폜
 */
template< typename C, class T, class V >
basic_v_string<C,T,V>&
basic_v_string<C,T,V>::erase(std::size_t pos, std::size_t n)
{
	check_pos_len(pos, n);
	if (n) {
		vec_.erase(ite(pos), ite(pos+n));
		V_STRING_APPEND_EOS();
	}
	return *this;
}


/** posڂ1폜
 */
template< typename C, class T, class V >
typename basic_v_string<C,T,V>::iterator
basic_v_string<C,T,V>::erase(typename basic_v_string<C,T,V>::iterator pos)
{
  #ifdef V_STRING_ALWAYS_APPEND_NULL_CHAR
	iterator it(end());
	check_pos(pos);
	if (pos < end()) {
		it = vec_.erase(pos);
		V_STRING_APPEND_EOS();
	}
	return it;
  #else
	check_pos(pos);
	if (pos < end())
		return vec_.erase(pos);
	return end();
  #endif
}


/** firstlastO܂ł̕폜
 */
template< typename C, class T, class V >
typename basic_v_string<C,T,V>::iterator
basic_v_string<C,T,V>::erase(
		typename basic_v_string<C,T,V>::iterator first,
		typename basic_v_string<C,T,V>::iterator last)
{
	check_pos(first);
	if (last < first) {
		throw_out_of_range();
		return end();
	}
	if (last > end())
		last = end();
  #ifdef V_STRING_ALWAYS_APPEND_NULL_CHAR
	iterator it = vec_.erase(first, last);
	V_STRING_APPEND_EOS();
	return it;
  #else
	return vec_.erase(first, last);
  #endif
}




// -------------------------------
// }

/** str2pos2n2Apos1ɑ}.
 */
template< typename C, class T, class V >
basic_v_string<C,T,V>&
basic_v_string<C,T,V>::insert(
		std::size_t						pos1,
		const basic_v_string<C,T,V>&	str2,
		std::size_t						pos2,
		std::size_t						n2	)
{
	str2.check_pos_len(pos2, n2);
	if (n2) {
		check_pos(pos1);
		vec_.insert( ite(pos1), str2.ptr(pos2), str2.ptr(pos2+n2) );
		V_STRING_APPEND_EOS();
	}
	return *this;
}


/** c2n2Apos1ɑ}.
 */
template< typename C, class T, class V >
basic_v_string<C,T,V>&
basic_v_string<C,T,V>::insert(std::size_t pos1, std::size_t n2, C c2)
{
	if (n2) {
		check_pos(pos1);
		vec_.insert(ite(pos1), n2, c2);
		V_STRING_APPEND_EOS();
	}
	return *this;
}


/** cstr2Apos1ɑ}.
 */
template< typename C, class T, class V >
basic_v_string<C,T,V>&
basic_v_string<C,T,V>::insert(std::size_t pos1, const C* cstr2)
{
	check_pos(pos1);
	std::size_t l2 = T::length(cstr2);
	if (l2) {
		vec_.insert(ite(pos1), &cstr2[0], &cstr2[l2]);
	} else {
		vec_.resize(pos1);
	}
	V_STRING_APPEND_EOS();
	return *this;
}


/** cary2n2Apos1ɑ}.
 */
template< typename C, class T, class V >
basic_v_string<C,T,V>&
basic_v_string<C,T,V>::insert(std::size_t pos1, const C* cary2, std::size_t n2)
{
	check_pos(pos1);
	if (n2) {
		vec_.insert(ite(pos1), &cary2[0], &cary2[n2]);
	} else {
		vec_.resize(pos1);
 	}
	V_STRING_APPEND_EOS();
	return *this;
}


/** c2Apos1ɑ}.
 */
template< typename C, class T, class V >
typename basic_v_string<C,T,V>::iterator
basic_v_string<C,T,V>::insert(typename basic_v_string<C,T,V>::iterator pos1, C c2)
{
	iterator it(end());
	if (begin() <= pos1 && pos1 <= end()) {
		it = vec_.insert(pos1, c2);
		V_STRING_APPEND_EOS();
	} else {
		throw_out_of_range();
	}
	return it;
}



/** c2n2Apos1ɑ}.
 */
template< typename C, class T, class V >
void
basic_v_string<C,T,V>::insert(typename basic_v_string<C,T,V>::iterator pos1, std::size_t n2, C c2)
{
	if (begin() <= pos1 && pos1 <= end()) {
		vec_.insert(pos1, n2, c2);
		V_STRING_APPEND_EOS();
	} else {
		throw_out_of_range();
	}
}



/** Ce[^[first2`last2)͈̔͂̕Apos1ɑ}.
 */
template< typename C, class T, class V >
template< typename InpIte >
void
basic_v_string<C,T,V>::insert(typename basic_v_string<C,T,V>::iterator pos1, InpIte first2, InpIte last2)
{
	if (begin() <= pos1 && pos1 <= end()) {
		vec_.insert(pos1, first2, last2);
		V_STRING_APPEND_EOS();
	} else {
		throw_out_of_range();
	}
}



// -------------------------------
// u

/** pos1n1Astr2pos2n2ɁAu.
 */
template< typename C, class T, class V >
basic_v_string<C,T,V>&
basic_v_string<C,T,V>::replace(
		std::size_t						pos1,
		std::size_t						n1	,
		const basic_v_string<C,T,V>&	str2,
		std::size_t						pos2,
		std::size_t						n2	)
{
	str2.check_pos_len(pos2, n2);
	check_pos_len(pos1, n1);
	vec_.erase( ite(pos1), ite(pos1+n1) );
	vec_.insert( ite(pos1), str2.ite(pos2), str2.ite(pos2+n2) );
	V_STRING_APPEND_EOS();
	return *this;
}



/** pos1n1Ac2n2ɁAu.
 */
template< typename C, class T, class V >
basic_v_string<C,T,V>&
basic_v_string<C,T,V>::replace(std::size_t pos1, std::size_t n1, std::size_t n2, C c2)
{
	check_pos_len(pos1, n1);
	vec_.erase( ite(pos1), ite(pos1+n1) );
	vec_.insert(ite(pos1), n2, c2);
	V_STRING_APPEND_EOS();
	return *this;
}


/** pos1n1Acstr2ɁAu.
 */
template< typename C, class T, class V >
basic_v_string<C,T,V>&
basic_v_string<C,T,V>::replace(std::size_t pos1, std::size_t n1, const C* cstr2)
{
	check_pos_len(pos1, n1);
	vec_.erase( ite(pos1), ite(pos1+n1) );
	std::size_t l2 = T::length(cstr2);
	vec_.insert(ite(pos1), &cstr2[0], &cstr2[l2]);
	V_STRING_APPEND_EOS();
	return *this;
}


/** pos1n1Acary2n2ɁAu.
 */
template< typename C, class T, class V >
basic_v_string<C,T,V>&
basic_v_string<C,T,V>::replace(std::size_t pos1, std::size_t n1, const C* cary2, std::size_t n2)
{
	check_pos_len(pos1, n1);
	vec_.erase( ite(pos1), ite(pos1+n1) );
	vec_.insert(ite(pos1), &cary2[0], &cary2[n2]);
	V_STRING_APPEND_EOS();
	return *this;
}




/** [first1,last1)͈̔͂Astr2ɁAu.
 */
template< typename C, class T, class V >
basic_v_string<C,T,V>&
basic_v_string<C,T,V>::replace(
	typename basic_v_string<C,T,V>::iterator	first1,
	typename basic_v_string<C,T,V>::iterator	last1,
	const basic_v_string<C,T,V>&				str2)
{
	check_range(first1, last1);
	vec_.erase(first1, last1);
	vec_.insert( first1, str2.begin(), str2.end() );
	V_STRING_APPEND_EOS();
	return *this;
}



/** [first1,last1)͈̔͂AcstrɁAu.
 */
template< typename C, class T, class V >
basic_v_string<C,T,V>&
basic_v_string<C,T,V>::replace(
	typename basic_v_string<C,T,V>::iterator	first1,
	typename basic_v_string<C,T,V>::iterator	last1,
	const C*									cstr2)
{
	check_range(first1, last1);
	vec_.erase(first1, last1);
	std::size_t l2 = T::length(cstr2);
	vec_.insert( first1, &cstr2[0], &cstr2[l2] );
	V_STRING_APPEND_EOS();
	return *this;
}



/** [first1,last1)͈̔͂AcarynɁAu.
 */
template< typename C, class T, class V >
basic_v_string<C,T,V>&
basic_v_string<C,T,V>::replace(
	typename basic_v_string<C,T,V>::iterator	first1,
	typename basic_v_string<C,T,V>::iterator	last1,
	const C*									cary2,
	std::size_t									n2	)
{
	check_range(first1, last1);
	vec_.erase(first1, last1);
	vec_.insert( first1, &cary2[0], &cary2[n2] );
	V_STRING_APPEND_EOS();
	return *this;
}



/** [first1,last1)͈̔͂Ac2n2ɁAu.
 */
template< typename C, class T, class V >
basic_v_string<C,T,V>&
basic_v_string<C,T,V>::replace(
	typename basic_v_string<C,T,V>::iterator	first1,
	typename basic_v_string<C,T,V>::iterator	last1,
	std::size_t									n2,
	C											c2)
{
	check_range(first1, last1);
	vec_.erase(first1, last1);
	vec_.insert(first1, n2, c2);
	V_STRING_APPEND_EOS();
	return *this;
}



/** [first1,last1)͈̔͂A̓Ce[^[first2,last2)̕ɁAu.
 */
template< typename C, class T, class V >
template< typename InpIte >
basic_v_string<C,T,V>&
basic_v_string<C,T,V>::replace(
	typename basic_v_string<C,T,V>::iterator	first1,
	typename basic_v_string<C,T,V>::iterator	last1,
	InpIte										first2,
	InpIte										last2)
{
	check_range(first1, last1);
	vec_.erase(first1,	last1);
	vec_.insert(first1, first2, last2);
	V_STRING_APPEND_EOS();
	return *this;
}



// -------------------------------
// 


/**  c2̌ʒuAnposAԂ
 */
template<typename C, class T, class V> inline
std::size_t		basic_v_string<C,T,V>::find(C c2) const {
	return find_1(ptr(0), 0, vec_.size(), c2);
}



/** pos1ȍ~  c2 ̌ʒuAnposAԂ
 */
template<typename C, class T, class V> inline
std::size_t		basic_v_string<C,T,V>::find(C c2, std::size_t pos1) const {
	std::size_t l1 = vec_.size();
	if (pos1 > l1)
		pos1 = l1;
	l1 -= pos1;
	return find_1(ptr(0), pos1, l1, c2);
}


/** str2TAʒuԂBnposԂ
 */
template<typename C, class T, class V> inline
std::size_t		basic_v_string<C,T,V>::find(const basic_v_string<C,T,V>& str2) const
{
	//x return find(str2.ptr(0), 0, str2.size());
	return find_str( ptr(0), 0, size(), str2.ptr(0), str2.size() );
}


/** pos1  str2TAʒuԂBnposԂ
 */
template<typename C, class T, class V> inline
std::size_t		basic_v_string<C,T,V>::find(const basic_v_string<C,T,V>& str2, std::size_t pos1) const
{
	return find(str2.ptr(0), pos1, str2.size());
}


/** cstr2 TAʒuԂBnposԂ
 */
template<typename C, class T, class V> inline
std::size_t		basic_v_string<C,T,V>::find(const C* cstr2) const
{
	std::size_t l2 = cstr2 ? T::length(cstr2) : 0;
	//x return find(cstr2, 0, l2);
	return find_str(ptr(0), 0, size(), cstr2, l2);
}


/** pos1  cstr2 TAʒuԂBnposԂ
 */
template<typename C, class T, class V> inline
std::size_t		basic_v_string<C,T,V>::find(const C* cstr2, std::size_t pos1) const
{
	std::size_t l2 = cstr2 ? T::length(cstr2) : 0;
	return find(cstr2, pos1, l2);
}


/** pos1  cary2nTAʒuԂBnposԂ
 */
template<typename C, class T, class V>
std::size_t		basic_v_string<C,T,V>::find(const C* cary2, std::size_t pos1, std::size_t n2) const
{
	std::size_t		n1 = size();
	if (pos1 > n1)
		return npos;	// pos1 = n1;
	n1 -= pos1;
	return find_str(ptr(0), pos1, n1, cary2, n2);
}



/// pos1  cary2nTAʒuԂBnposԂ.
/// [private]
template<typename C, class T, class V>
std::size_t		basic_v_string<C,T,V>::find_str(const C* cary1, std::size_t ofs1, std::size_t n1, const C* cary2, std::size_t n2)
{
	if (ofs1 > n1)
		return npos;	// pos1 = n1;

	// TȂ΁A0 (ł悢?)
	if (n2 == 0 || cary2 == NULL)
		return ofs1;

	if (n1 == 0)	// n1 0Ȃ猩Ȃ͂...
		return npos;

	if (n2 > n1)	// n2̂قጩ͂Ȃ
		return npos;

	if (n2 == 1)	// 11p
		return find_1(cary1, ofs1, n1, cary2[0]);

	const C*	src1	 = cary1+ofs1;
	const C*	cary1end = src1 + n1 - n2;
	const C*	key2	 = cary2;
	const C*	key2end  = key2 + n2;
	C 			k2		 = *key2++;		// p^[̍ŏ

  RETRY:
	while (src1 <= cary1end) {
		int c = *src1++;
		if (c == k2) {
			const C* s1  = src1;
			const C* kp2 = key2;
			// if (k2 != key2end)		// keyE - key >= 1 Ȃ̂ŁAifsv
			{
				do {
					//x if (t == se) return npos;
					c = *s1++;
					c = c - *kp2++;
					if (c)
						goto RETRY;
				} while (kp2 != key2end);
			}
			return src1 - 1 - cary1;
		}
	}
	return npos;
}


///  c2̌ʒuAnposAԂ
/// [private]
template<typename C, class T, class V>
std::size_t		basic_v_string<C,T,V>::find_1(const C* cary1, std::size_t ofs1, std::size_t n1, C c2)
{
	if (n1 == 0 || cary1 == 0)
		return npos;
	const C* 	p1 = T::find(cary1+ofs1, n1, c2);
	std::size_t n  = npos;
	if (p1)
		n = p1 - cary1;
	return n;
}



//-----------------------
// tT

/** t  c2̌ʒuAnposAԂ
 */
template<typename C, class T, class V> inline
std::size_t		basic_v_string<C,T,V>::rfind(C c2) const {
	return rfind_1(ptr(0), vec_.size(), c2);
}



/** t pos1   c2 ̌ʒuAnposAԂ
 */
template<typename C, class T, class V> inline
std::size_t		basic_v_string<C,T,V>::rfind(C c2, std::size_t pos1) const {
	if (pos1 < npos)
		++pos1;
	std::size_t l1 = vec_.size();
	if (l1 > pos1)
		l1 = pos1;
	return rfind_1(ptr(0), l1, c2);
}



/** t str2 TAʒuԂBnposԂ
 */
template<typename C, class T, class V> inline
std::size_t		basic_v_string<C,T,V>::rfind(const basic_v_string<C,T,V>& str2) const
{
	return rfind_str( ptr(0), size(), str2.ptr(0), str2.size() );
}


/** t pos1  str2TAʒuԂBnposԂ
 */
template<typename C, class T, class V> inline
std::size_t		basic_v_string<C,T,V>::rfind(const basic_v_string<C,T,V>& str2, std::size_t pos1) const
{
	return rfind(str2.ptr(0), pos1, str2.size());
}


/** t cstr2 TAʒuԂBnposԂ
 */
template<typename C, class T, class V> inline
std::size_t		basic_v_string<C,T,V>::rfind(const C* cstr2) const
{
	std::size_t l2 = cstr2 ? T::length(cstr2) : 0;
	return rfind_str(ptr(0), size(), cstr2, l2);
}


/** t pos1  cstr2 TAʒuԂBnposԂ
 */
template<typename C, class T, class V> inline
std::size_t		basic_v_string<C,T,V>::rfind(const C* cstr2, std::size_t pos1) const
{
	std::size_t l2 = cstr2 ? T::length(cstr2) : 0;
	return rfind(cstr2, pos1, l2);
}


/** t pos1  cary2nTAʒuԂBnposԂ
 */
template<typename C, class T, class V>
std::size_t		basic_v_string<C,T,V>::rfind(const C* cary2, std::size_t pos1, std::size_t n2) const
{
	if (pos1 < npos)
		++pos1;
	std::size_t		n1 = size();
	if (n1 > pos1)
		n1 = pos1;
	return rfind_str(ptr(0), n1, cary2, n2);
}


/// t pos1  cary2nTAʒuԂBnposԂ
/// [private]
template<typename C, class T, class V>
std::size_t		basic_v_string<C,T,V>::rfind_str(const C* cary1, std::size_t n1, const C* cary2, std::size_t n2)
{
	// TȂ΁A0 (ł悢?)
	if (n2 == 0 || cary2 == NULL)
		return 0;

	if (n1 == 0)	// n1 0Ȃ猩Ȃ͂...
		return npos;

	if (n2 > n1)	// n2̂قጩ͂Ȃ
		return npos;

	if (n2 == 1)	// 11p
		return rfind_1(cary1, n1, cary2[0]);

	//const C*	cary1end = cary1 + n1 - n2;
	const C*	cary1end = cary1 + n1; // - n2;
	const C*	src1	 = cary1end;
	const C*	key2	 = cary2;
	const C*	key2end  = key2 + n2;
	C 			k2		 = *key2++;		// p^[̍ŏ

  RETRY:
	while (--src1 >= cary1) {
		int c = *src1;
		if (c == k2) {
			const C* s1  = src1+1;
			const C* kp2 = key2;
			// if (k2 != key2end)		// keyE - key >= 1 Ȃ̂ŁAifsv
			{
				do {
					//x if (t == se) return npos;
					c = *s1++;
					c = c - *kp2++;
					if (c)
						goto RETRY;
				} while (kp2 != key2end);
			}
			return src1 - cary1;
		}
	}
	return npos;
}


/// tT cary1n1  c2΂̈ʒuAnposAԂ.
/// [private]
template<typename C, class T, class V>
std::size_t		basic_v_string<C,T,V>::rfind_1(const C* cary1, std::size_t n1, C c2)
{
	if (n1 == 0 || cary1 == 0)
		return npos;
	const C* 	s1 = cary1 + n1;
	do {
		--s1;
		if (*s1 == c2)
			return s1 - cary1;
	} while (s1 >= cary1);
	return npos;
}



//------------------------
// w蕶񒆂̂Âꂩꕶƃ}b`̂TB


/**  čʒuAnposAԂ
 */
template<typename C, class T, class V> inline
std::size_t		basic_v_string<C,T,V>::find_first_of(C c) const {
	return find(c);
}


/** pos1ȍ~  c2 ̌ʒuAnposAԂ
 */
template<typename C, class T, class V> inline
std::size_t		basic_v_string<C,T,V>::find_first_of(C c2, std::size_t pos1) const {
	return find(c2, pos1);
}




/** pos1ڂn1̒ɁAcary2n2̉ꂩ1邩T.
 *	΂̈ʒuAȂnposԂ.
 */
template<typename C, class T, class V> inline
std::size_t		basic_v_string<C,T,V>::find_first_of(const C* cary2, std::size_t pos1, std::size_t n2) const
{
	std::size_t		n1 = size();
	if (pos1 > n1)
		return npos;	// pos1 = n1;
	n1 -= pos1;
	return fnd_first_of(ptr(0), pos1, n1, cary2, n2);
}



/** pos1ڂn1̒ɁAstr2̉ꂩ1邩T.
 *	΂̈ʒuAȂnposԂ.
 */
template<typename C, class T, class V> inline
std::size_t		basic_v_string<C,T,V>::find_first_of(const basic_v_string<C,T,V>& str2) const
{
	return fnd_first_of(ptr(0), 0U, size(), str2.ptr(0), str2.size());
}



/** pos1ڂn1̒ɁAstr2̉ꂩ1邩T.
 *	΂̈ʒuAȂnposԂ.
 */
template<typename C, class T, class V> inline
std::size_t		basic_v_string<C,T,V>::find_first_of(const basic_v_string<C,T,V>& str2, std::size_t pos1) const
{
	return find_first_of(str2.ptr(0), pos1, str2.size());
}




/** pos1ڂn1̒ɁAcstr2̉ꂩ1邩T.
 *	΂̈ʒuAȂnposԂ.
 */
template<typename C, class T, class V>
std::size_t		basic_v_string<C,T,V>::find_first_of(const C* cstr2) const
{
	std::size_t		n2 = cstr2 ? T::length(cstr2) : 0;
	std::size_t		n1 = size();
	return fnd_first_of(ptr(0), 0, n1, cstr2, n2);
}



/** pos1ڂn1̒ɁAcstr2̉ꂩ1邩T.
 *	΂̈ʒuAȂnposԂ.
 */
template<typename C, class T, class V>
std::size_t		basic_v_string<C,T,V>::find_first_of(const C* cstr2, std::size_t pos1) const
{
	std::size_t		n2 = cstr2 ? T::length(cstr2) : 0;
	return find_first_of( cstr2, pos1, n2 );
}



/// cary1ofs1ڂn1̒n2cary2̉ꂩ̕邩T.
/// ΂̈ʒuAȂnposԂ.
/// [private]
template<typename C, class T, class V>
std::size_t
basic_v_string<C,T,V>::fnd_first_of(
		const C*	cary1,
		std::size_t ofs1,
		std::size_t n1,
		const C*	cary2,
		std::size_t n2)
{
	// TȂ΁Anpos (ł悢?)
	if (n2 == 0 || cary2 == NULL)
		return npos;

	if (n1 == 0)	// n1 0Ȃ猩Ȃ͂...
		return npos;

	if (n2 == 1)	// 11p
		return find_1(cary1, ofs1, n1, cary2[0]);

	const C*	s1 = cary1+ofs1;
	do {
		char_type c1 = *s1++;
		const C* p = T::find(cary2, n2, c1);
		if (p)	// A
			return	s1-1-cary1;
	} while (--n1);
	return npos;
}



//------------------------
// w蕶񒆂̂Âꂩꕶƃ}b`̂tTB


/**  čʒuAnposAԂ
 */
template<typename C, class T, class V> inline
std::size_t		basic_v_string<C,T,V>::find_last_of(C c) const {
	return rfind(c);
}


/** pos1ȍ~  c2 ̌ʒuAnposAԂ
 */
template<typename C, class T, class V> inline
std::size_t		basic_v_string<C,T,V>::find_last_of(C c2, std::size_t pos1) const {
	return rfind(c2, pos1);
}


/** pos1ڂn1̒ɁAcary2n2̉ꂩ1邩T.
 *	΂̈ʒuAȂnposԂ.
 */
template<typename C, class T, class V> inline
std::size_t		basic_v_string<C,T,V>::find_last_of(const C* cary2, std::size_t pos1, std::size_t n2) const
{
	if (pos1 < npos)
		++pos1;
	std::size_t		n1 = size();
	if (n1 > pos1)
		n1 = pos1;
	//n1 -= pos1;
	return fnd_last_of(ptr(0), n1, cary2, n2);
}


/** pos1ڂn1̒ɁAstr2̉ꂩ1邩T.
 *	΂̈ʒuAȂnposԂ.
 */
template<typename C, class T, class V> inline
std::size_t		basic_v_string<C,T,V>::find_last_of(const basic_v_string<C,T,V>& str2) const
{
	return fnd_last_of(ptr(0), size(), str2.ptr(0), str2.size());
}


/** pos1ڂn1̒ɁAstr2̉ꂩ1邩T.
 *	΂̈ʒuAȂnposԂ.
 */
template<typename C, class T, class V> inline
std::size_t		basic_v_string<C,T,V>::find_last_of(const basic_v_string<C,T,V>& str2, std::size_t pos1) const
{
	return find_last_of(str2.ptr(0), pos1, str2.size());
}



/** pos1ڂn1̒ɁAcstr2̉ꂩ1邩T.
 *	΂̈ʒuAȂnposԂ.
 */
template<typename C, class T, class V>
std::size_t		basic_v_string<C,T,V>::find_last_of(const C* cstr2) const
{
	std::size_t		n2 = cstr2 ? T::length(cstr2) : 0;
	return fnd_last_of(ptr(0), size(), cstr2, n2);
}


/** pos1ڂn1̒ɁAcstr2̉ꂩ1邩T.
 *	΂̈ʒuAȂnposԂ.
 */
template<typename C, class T, class V>
std::size_t		basic_v_string<C,T,V>::find_last_of(const C* cstr2, std::size_t pos1) const
{
	std::size_t		n2 = cstr2 ? T::length(cstr2) : 0;
	return find_last_of( cstr2, pos1, n2 );
}


/// cary1ofs1ڂn1̒n2cary2̉ꂩ̕邩T.
/// ΂̈ʒuAȂnposԂ.
/// [private]
template<typename C, class T, class V>
std::size_t
basic_v_string<C,T,V>::fnd_last_of(
		const C*	cary1,
		std::size_t n1,
		const C*	cary2,
		std::size_t n2)
{
	// TȂ΁Anpos (ł悢?)
	if (n2 == 0 || cary2 == NULL)
		return npos;

	if (n1 == 0)	// n1 0Ȃ猩Ȃ͂...
		return npos;

	if (n2 == 1)	// 11p
		return rfind_1(cary1, n1, cary2[0]);

	const C*	s1 = cary1+n1;
	do {
		char_type c1 = *--s1;
		const C* p = T::find(cary2, n2, c1);
		if (p)	// A
			return	s1-cary1;
	} while (s1 > cary1);
	return npos;
}




//------------------------
// w蕶񒆂̂Â̈ꕶƂ}b`Ȃ̂TB


/**  cȊǑʒuAnposAԂ
 */
template<typename C, class T, class V> inline
std::size_t		basic_v_string<C,T,V>::find_first_not_of(C c) const {
	return fnd_first_not_of(ptr(0), 0, size(), c);
}


/** pos1ȍ~  c2 ȊǑʒuAnposAԂ
 */
template<typename C, class T, class V> inline
std::size_t		basic_v_string<C,T,V>::find_first_not_of(C c2, std::size_t pos1) const {
	std::size_t n1 = size();
	if (pos1 > n1)
		return npos;	//x pos1 = l1;
	n1 -= npos;
	return fnd_first_not_of(ptr(0), pos1, n1, c2);
}


/** pos1ڂn1̒ɁAcary2n2̉1ȊO邩T.
 *	΂̈ʒuAȂnposԂ.
 */
template<typename C, class T, class V> inline
std::size_t		basic_v_string<C,T,V>::find_first_not_of(const C* cary2, std::size_t pos1, std::size_t n2) const
{
	std::size_t		n1 = size();
	if (pos1 > n1)
		return npos;	// pos1 = n1;
	n1 -= pos1;
	return fnd_first_not_of(ptr(0), pos1, n1, cary2, n2);
}


/** pos1ڂn1̒ɁAstr2̉1ȊO邩T.
 *	΂̈ʒuAȂnposԂ.
 */
template<typename C, class T, class V> inline
std::size_t		basic_v_string<C,T,V>::find_first_not_of(const basic_v_string<C,T,V>& str2) const
{
	return fnd_first_not_of(ptr(0), 0U, size(), str2.ptr(0), str2.size());
}


/** pos1ڂn1̒ɁAstr2̉1ȊO邩T.
 *	΂̈ʒuAȂnposԂ.
 */
template<typename C, class T, class V> inline
std::size_t		basic_v_string<C,T,V>::find_first_not_of(const basic_v_string<C,T,V>& str2, std::size_t pos1) const
{
	return find_first_not_of(str2.ptr(0), pos1, str2.size());
}


/** pos1ڂn1̒ɁAcstr2̉1ȊO邩T.
 *	΂̈ʒuAȂnposԂ.
 */
template<typename C, class T, class V>
std::size_t		basic_v_string<C,T,V>::find_first_not_of(const C* cstr2) const
{
	std::size_t		n2 = cstr2 ? T::length(cstr2) : 0;
	std::size_t		n1 = size();
	return fnd_first_not_of(ptr(0), 0, n1, cstr2, n2);
}


/** pos1ڂn1̒ɁAcstr2̉1ȊO邩T.
 *	΂̈ʒuAȂnposԂ.
 */
template<typename C, class T, class V>
std::size_t		basic_v_string<C,T,V>::find_first_not_of(const C* cstr2, std::size_t pos1) const
{
	std::size_t		n2 = cstr2 ? T::length(cstr2) : 0;
	return find_first_not_of( cstr2, pos1, n2 );
}


/// cary1ofs1ڂn1̒n2cary2̉ꂩ̕邩T.
/// ΂̈ʒuAȂnposԂ.
/// [private]
template<typename C, class T, class V>
std::size_t
basic_v_string<C,T,V>::fnd_first_not_of(
		const C*	cary1,
		std::size_t ofs1,
		std::size_t n1,
		const C*	cary2,
		std::size_t n2)
{
	// TȂ΁Anpos (ł悢?)
	if (n2 == 0 || cary2 == NULL)
		return ofs1;

	if (n1 == 0)	// n1 0Ȃ猩Ȃ͂...
		return npos;

	if (n2 == 1)	// 11p
		return fnd_first_not_of(cary1, ofs1, n1, cary2[0]);

	const C*	s1 = cary1+ofs1;
	do {
		char_type c1 = *s1++;
		const C* p = T::find(cary2, n2, c1);
		if (p == 0)	// A
			return	s1-1-cary1;
	} while (--n1);
	return npos;
}


///  cȊǑʒuAnposAԂ.
/// [private]
template<typename C, class T, class V>
std::size_t		basic_v_string<C,T,V>::fnd_first_not_of(const C* cary1, std::size_t ofs1, std::size_t n1, C c2)
{
	if (cary1 == 0 || n1 == 0)
		return npos;
	const C* s = cary1 + ofs1;
	const C* e = s + n1;
	do {
		if (*s != c2)
			return s - cary1;
		++s;
	} while (s != e);
	return npos;
}




//------------------------
// w蕶񒆂̂Â̈ꕶƂ}b`Ȃ̂tTB


/** tŁA cȊǑʒuAnposAԂ
 */
template<typename C, class T, class V> inline
std::size_t		basic_v_string<C,T,V>::find_last_not_of(C c) const {
	return fnd_last_not_of(ptr(0), size(), c);
}


/** tŁApos1ȑO  c2 ȊǑʒuAnposAԂ
 */
template<typename C, class T, class V> inline
std::size_t		basic_v_string<C,T,V>::find_last_not_of(C c2, std::size_t pos1) const {
	if (pos1 < npos)
		++pos1;
	std::size_t		n1 = size();
	if (n1 > pos1)
		n1 = pos1;
	return fnd_last_not_of(ptr(0), n1, c2);
}


/** tŁApos1ڈȑOɁAcary2n2̉1ȊO邩T.
 *	΂̈ʒuAȂnposԂ.
 */
template<typename C, class T, class V> inline
std::size_t		basic_v_string<C,T,V>::find_last_not_of(const C* cary2, std::size_t pos1, std::size_t n2) const
{
	if (pos1 < npos)
		++pos1;
	std::size_t		n1 = size();
	if (n1 > pos1)
		n1 = pos1;
	return fnd_last_not_of(ptr(0), n1, cary2, n2);
}


/** tŁAstr2̉1ȊO邩T.
 *	΂̈ʒuAȂnposԂ.
 */
template<typename C, class T, class V> inline
std::size_t		basic_v_string<C,T,V>::find_last_not_of(const basic_v_string<C,T,V>& str2) const
{
	return fnd_last_not_of(ptr(0), size(), str2.ptr(0), str2.size());
}


/** tŁAstr2̉1ȊO邩T.
 *	΂̈ʒuAȂnposԂ.
 */
template<typename C, class T, class V> inline
std::size_t		basic_v_string<C,T,V>::find_last_not_of(const basic_v_string<C,T,V>& str2, std::size_t pos1) const
{
	return find_last_not_of(str2.ptr(0), pos1, str2.size());
}


/** tŁAcstr2̉1ȊO邩T.
 *	΂̈ʒuAȂnposԂ.
 */
template<typename C, class T, class V>
std::size_t		basic_v_string<C,T,V>::find_last_not_of(const C* cstr2) const
{
	std::size_t		n2 = cstr2 ? T::length(cstr2) : 0;
	std::size_t		n1 = size();
	return fnd_last_not_of(ptr(0), n1, cstr2, n2);
}


/** tŁAcstr2̉1ȊO邩T.
 *	΂̈ʒuAȂnposԂ.
 */
template<typename C, class T, class V>
std::size_t		basic_v_string<C,T,V>::find_last_not_of(const C* cstr2, std::size_t pos1) const
{
	std::size_t		n2 = cstr2 ? T::length(cstr2) : 0;
	return find_last_not_of( cstr2, pos1, n2 );
}


/// tŁAcary1n1̒n2cary2̉ꂩ̕邩T.
/// ΂̈ʒuAȂnposԂ.
/// [private]
template<typename C, class T, class V>
std::size_t
basic_v_string<C,T,V>::fnd_last_not_of(
		const C*	cary1,
		std::size_t n1,
		const C*	cary2,
		std::size_t n2)
{
	// TȂ΁Anpos (ł悢?)
	if (n2 == 0 || cary2 == NULL)
		return n1-1;	//npos;

	if (n1 == 0)	// n1 0Ȃ猩Ȃ͂...
		return npos;

	if (n2 == 1)	// 11p
		return fnd_last_not_of(cary1, n1, cary2[0]);

	const C*		s1 = cary1+n1;
	do {
		char_type 	c1 = *--s1;
		const C*  	p  = T::find(cary2, n2, c1);
		if (p == 0)	// Ȃok
			return	s1-cary1;
	} while (--n1);
	return npos;
}


///  cȊǑʒuAnposAԂ
/// [private]
template<typename C, class T, class V>
std::size_t		basic_v_string<C,T,V>::fnd_last_not_of(const C* cary1, std::size_t n1, C c2)
{
	if (cary1 == 0 || n1 == 0)
		return npos;
	const C* s = cary1 + n1;
	do {
		--s;
		if (*s != c2)
			return s - cary1;
	} while (s != cary1);
	return npos;
}






//---------------------------------------------------------------------------------
//---------------------------------------------------------------------------------
// 񃁃o[֐

// string + string
template<typename C, class T, class V> inline
basic_v_string<C,T,V> operator+(const basic_v_string<C,T,V>& lhs, const basic_v_string<C,T,V>& rhs) {
	return basic_v_string<C,T,V>(lhs) += rhs;
}

// C* + string
template<typename C, class T, class V> inline
basic_v_string<C,T,V> operator+(const C* lhs, const basic_v_string<C,T,V>& rhs) {
	return basic_v_string<C,T,V>(lhs) += rhs;
}

// C + string
template<typename C, class T, class V> inline
basic_v_string<C,T,V> operator+(C lhs, const basic_v_string<C,T,V>& rhs) {
	return basic_v_string<C,T,V>(1, lhs) += rhs;
}

// string + C*
template<typename C, class T, class V> inline
basic_v_string<C,T,V> operator+(const basic_v_string<C,T,V>& lhs, const C* rhs) {
	return basic_v_string<C,T,V>(lhs) += rhs;
}

// string + C
template<typename C, class T, class V> inline
basic_v_string<C,T,V> operator+(const basic_v_string<C,T,V>& lhs, C rhs) {
	return basic_v_string<C,T,V>(lhs) += rhs;
}



// string == string
template<typename C, class T, class V> inline
bool operator==(const basic_v_string<C,T,V>& lhs, const basic_v_string<C,T,V>& rhs) {
	return lhs.compare(rhs) == 0;
}

// string == C*
template<typename C, class T, class V> inline
bool operator==(const basic_v_string<C,T,V>& lhs, const C* rhs) {
	return lhs.compare(rhs) == 0;
}

// C* == string
template<typename C, class T, class V> inline
bool operator==(const C* lhs, const basic_v_string<C,T,V>& rhs) {
	return rhs.compare(lhs) == 0;
}



// string != string
template<typename C, class T, class V> inline
bool operator!=(const basic_v_string<C,T,V>& lhs, const basic_v_string<C,T,V>& rhs) {
	return lhs.compare(rhs) != 0;
}

// string != C*
template<typename C, class T, class V> inline
bool operator!=(const basic_v_string<C,T,V>& lhs, const C* rhs) {
	return lhs.compare(rhs) != 0;
}

// C* != string
template<typename C, class T, class V> inline
bool operator!=(const C* lhs, const basic_v_string<C,T,V>& rhs) {
	return rhs.compare(lhs) != 0;
}



// string < string
template<typename C, class T, class V> inline
bool operator < (const basic_v_string<C,T,V>& lhs, const basic_v_string<C,T,V>& rhs) {
	return lhs.compare(rhs) < 0;
}

// string < C*
template<typename C, class T, class V> inline
bool operator < (const basic_v_string<C,T,V>& lhs, const C* rhs) {
	return lhs.compare(rhs) < 0;
}

// C* < string
template<typename C, class T, class V> inline
bool operator < (const C* lhs, const basic_v_string<C,T,V>& rhs) {
	return rhs.compare(lhs) > 0;
}



// string > string
template<typename C, class T, class V> inline
bool operator > (const basic_v_string<C,T,V>& lhs, const basic_v_string<C,T,V>& rhs) {
	return lhs.compare(rhs) > 0;
}

// string > C*
template<typename C, class T, class V> inline
bool operator > (const basic_v_string<C,T,V>& lhs, const C* rhs) {
	return lhs.compare(rhs) > 0;
}

// C* > string
template<typename C, class T, class V> inline
bool operator > (const C* lhs, const basic_v_string<C,T,V>& rhs) {
	return rhs.compare(lhs) < 0;
}



// string <= string
template<typename C, class T, class V> inline
bool operator <= (const basic_v_string<C,T,V>& lhs, const basic_v_string<C,T,V>& rhs) {
	return lhs.compare(rhs) <= 0;
}

// string <= C*
template<typename C, class T, class V> inline
bool operator <= (const basic_v_string<C,T,V>& lhs, const C* rhs) {
	return lhs.compare(rhs) <= 0;
}

// C* <= string
template<typename C, class T, class V> inline
bool operator <= (const C* lhs, const basic_v_string<C,T,V>& rhs) {
	return rhs.compare(lhs) >= 0;
}



// string >= string
template<typename C, class T, class V> inline
bool operator >= (const basic_v_string<C,T,V>& lhs, const basic_v_string<C,T,V>& rhs) {
	return lhs.compare(rhs) >= 0;
}

// string >= C*
template<typename C, class T, class V> inline
bool operator >= (const basic_v_string<C,T,V>& lhs, const C* rhs) {
	return lhs.compare(rhs) >= 0;
}

// C* >= string
template<typename C, class T, class V> inline
bool operator >= (const C* lhs, const basic_v_string<C,T,V>& rhs) {
	return rhs.compare(lhs) <= 0;
}


// 
template<typename C, class T, class V> inline
void swap(basic_v_string<C,T,V>& lhs, basic_v_string<C,T,V>& rhs) {
	lhs.swap(rhs);
}


#if 0	// iostream֌W̓^[QbgŎgȂ̂ŃRgAEg.
// istream >> basic_v_string
template<typename C, class T, class V>
basic_istream<C,T>& operator>>(basic_istream<C, T>& is, basic_v_string<C,T,V>& str);

// ostream << basic_v_string
template<typename C, class T, class V>
basic_ostream<C, T>& operator>>(basic_ostream<C, T>& is, const basic_v_string<C,T,V>& str);


// istream̓͂basic_v_stringŎ󂯎B
// ftHgŉs܂ŁB
template<class C, class traits, class Allocator>
std::basic_istream<C, traits>&
getline(std::basic_istream<C, traits>& is,
	  	basic_v_string<C, traits, Allocator>& str,
		C delim = '\n');
#endif



#undef V_STRING_APPEND_EOS


#endif 		// V_STRING_H
